public class Heapsort {

    public static void main(String args[]) {
    	int N = Integer.parseInt(args[0]);
        int[] ary = new int[N+1];

        srand(123457);
		for (int i=1; i<=N; i++) {
		    ary[i] = rand();
		}

		heapsort(N, ary);
		System.out.println(ary[N]);
		System.out.println("Need to add testSort!");
    }

	public static void heapsort(int n, int[] ra) {
		int l, j, ir, i;
		int rra;

		l = (n >> 1) + 1;
		ir = n;
		while (true) {
		    if (l > 1) {
			rra = ra[--l];
		    } else {
			rra = ra[ir];
			ra[ir] = ra[1];
			if (--ir == 1) {
			    ra[1] = rra;
			    return;
			}
		    }
		    i = l;
		    j = l << 1;
		    while (j <= ir) {
			if (j < ir && ra[j] < ra[j+1]) { ++j; }
			if (rra < ra[j]) {
			    ra[i] = ra[j];
			    j += (i = j);
			} else {
			    j = ir + 1;
			}
		    }
		    ra[i] = rra;
		}
    }


    public static final long A = 16807;
	public static final long M = 2147483647;
	public static long X;

	public static void srand(int r) {
        X = r;
    }

	public static int rand() {
		X = (A * X) % M;
		return (int) X;
    }
}
